//  Obsluha displeje pres TM1637
//=============================================


#ifdef displej_TM1637_5
//----------------------------------------------
// zobrazi na displeji text z pole dis_popisy[]
void zobraz_text(byte polozka)
  {
    D_pamet[0] =  dis_popisy[polozka][4];                                             // pretoceni nejvyssich a nejnizsich radu pro spravne zobrazeni na spravnych jednotkych
    D_pamet[1] =  dis_popisy[polozka][3];
    D_pamet[2] =  dis_popisy[polozka][2];
    D_pamet[3] =  dis_popisy[polozka][1];
    D_pamet[4] =  dis_popisy[polozka][0];
    aktualizuj_displej();
  }
//----------------------------------------------



//----------------------------------------------
// odesle do datoveho pinu 8 bitu se soucasnym kmitanim pinu CLK. 
// Na zaver posle jeste jeden hodinovy impulz pro prijem ACK bitu - ten ale netestuji.
void zapis_data(byte data)
  {
    for(byte i = 0; i < 8; i++)
      {
        digitalWrite(pin_dis_CLK, LOW);
        delayMicroseconds(2);
        if(bitRead(data , i) == true) digitalWrite(pin_dis_DIN  , HIGH);
        else                          digitalWrite(pin_dis_DIN  , LOW);

        delayMicroseconds(2);

        digitalWrite(pin_dis_CLK, HIGH);
        delayMicroseconds(2);
      }

    digitalWrite(pin_dis_CLK, LOW);
    delayMicroseconds(10);
    
                                                                                      // (tady by se mel testovat signal ACK, ale kaslu na to)
    
    digitalWrite(pin_dis_CLK, HIGH);
    delayMicroseconds(2);
    
    digitalWrite(pin_dis_DIN, LOW);                                                   // ukonceni odesilani bajtu prepnutim obou pinu do LOW
    delayMicroseconds(2);
    digitalWrite(pin_dis_CLK, LOW);
    delayMicroseconds(2);
  }
//----------------------------------------------



//----------------------------------------------
// zapise do displeje obsah pole promennych D_pamet[]
//    (Nektere ty "delayMicroseconds()" jsou mozna zbytecne)
void aktualizuj_displej()
  {
    digitalWrite(pin_dis_CLK,LOW);
    digitalWrite(pin_dis_DIN,LOW);                                                    // start_kom
    delayMicroseconds(2);

    zapis_data(0b01000000);                                                           // automaticke zvetsovani adresy (pozice sedmisegmentovky)

    digitalWrite(pin_dis_CLK, HIGH);                                                  // stop_kom
    delayMicroseconds(2);
    digitalWrite(pin_dis_DIN, HIGH);
    delayMicroseconds(2);

    digitalWrite(pin_dis_DIN, LOW);                                                   // start_kom
    delayMicroseconds(2);

    zapis_data(0b11000000);                                                           // bit2 az bit0 = startovni pozice na nulte segmentovce (nejvic vlevo)

    zapis_data(D_pamet[0]);
    zapis_data(D_pamet[1]);
    zapis_data(D_pamet[2]);
    zapis_data(D_pamet[3]);
    zapis_data(D_pamet[4]); 

    digitalWrite(pin_dis_CLK, HIGH);                                                  // stop_kom
    delayMicroseconds(2);
    digitalWrite(pin_dis_DIN, HIGH);
    delayMicroseconds(2);

    digitalWrite(pin_dis_DIN, LOW);                                                   // start_kom
    delayMicroseconds(2);

    zapis_data(0b10001000 + jas_displeje);                                            // bit2 az bit0 nastaveni jasu (bit3 = 0/1 = zhasnout/rosvitit displej)

    digitalWrite(pin_dis_CLK, HIGH);                                                  // stop_kom
    delayMicroseconds(2);
    digitalWrite(pin_dis_DIN, HIGH);
    delayMicroseconds(2);
  }
//----------------------------------------------



//----------------------------------------------
// Zobrazeni cisla na  5-znakovem displeji
//  Uvodni nuly se nezobrazuji. (cislo 56 se zobrazi jako "   56")
//  Jedna nula pred desetinnou teckou se zobrazuje. Pri nastaveni napriklad 3 desetinnych mist a zobrazovanem cisle 6 ukaze displej " 0.006"
//  Nula pred desetinnou teckou se nezobrazi pouze v pripade zaporneho cisla se 4 desetinnymi misty: napriklad "-0,1234" se zobrazi jako "-.1234" ).
//  Znamenko minus se zobrazuje vzdycky na nejvyssi pozici (leva sedmisegmentovka).  (-7 = "-   7")
//  Pri zobrazeni cisla bez desetinnych mist se desetinna tecka vpravo nezobrazuje.  (78 = "   78")
//  Parametr 'styl' udava zpusob zobrazeni:
//       0 = zobrazi cislo pres cely displej (prepisuje nebo maze i 1. sedmisegmentovku zleva)
//       1 = zachova zobrazeny znak na prvni jednotce. Cislo pak musi byt v rozsahu 0 az 9999 (nesmi byt zaporne a nesmi byt moc velke).
//       2 = specialni pripad, kdy se zobrazuje napis "L   0" az "L  -99" (pri listovani v ulozenych hodnotach)
//       3 = zobrazeni odpoctu pri mereni svetla ve formatu "-20- " az "-0-  " (nahrada puvodniho sloupcoveho grafu)
//       4 = rezerva (puvodne tam bylo neco hodne podobne stylu 0 ale uz to nemuzu najit. Pro jistotu nechavam neobsazene.)
//       5 = styl zobrazeni odpoctu pri Hard Formatu (H.F.123)
//       6 = styl zobrazeni odpoctu pri dlouhych vypisech EEPROM (rd.123)
//       7 = styl zobrazeni odpoctu pri Soft Formatu (S.F.123)
void zobraz_cislo(int cislo, byte styl)
  {
    byte predtext = 0;                                                                // pro styly, ktere zobrazuji nejaky dlouhy odpocet (formatovani a vypisy) se pred cislem zobrazuji jeste nejake texty
    posledni_n = cislo;                                                               // Pamet posledniho zadaneho cisla kvuli aktualizaci zobrazeni pri zmene polohy desetinne tecky
    if (styl == 5)
      {
        styl = 0;
        predtext = 1;                                                                 // na prvnich sedmisegmentovkach se zobrazi znaky "HF." jako Hard Format
      }

    if (styl == 6)
      {
        styl = 0;
        predtext = 2;                                                                 // na prvnich sedmisegmentovkach se zobrazi znaky "rd." jako Read (vypis dlouhych dat z EEPROM)
      }

    if (styl == 7)
      {
        styl = 0;
        predtext = 3;                                                                 // na prvnich sedmisegmentovkach se zobrazi znaky "rd." jako Read (vypis dlouhych dat z EEPROM)
      }
   
    boolean znamenko = false;                                                         // Zapamatovat si znamenko, ktere se pak zobrazi na 1. segmentovce zleva (index 4)
    if (cislo < 0)                                                                    // Zaporna cisla ...
      {
        znamenko = true;                                                              // ... se prevedou na kladna, ale zapamatuje se znamenko
        cislo=abs(cislo);
      }

    boolean zobraz_nuly = false;                                                      // Nuly pred cislem se normalne nezobrazuji
                                                                                      // Prepnutim na true se zacnou zobrazovat uz od 1.pozice zleva na displeji

    if (styl == 3)                                                                    // zobrazeni cisla ve formatu "-nn- "
      {
        cislo = cislo * 100;                                                          // cislo se posune o 2 mista vlevo (priklad: z puvodniho cisla 15 se stane " 1500" a na displeji se zobrazi jen pozice tisicu a stovek)
        zobraz_nuly = true;                                                           // budou se zobrazovat nuly pred cislem, takze  napriklad z puvodniho 8 se stane "00800" a na displeji se v zaveru zobrazi "-08- "
        pozice_tecky = 0;                                                             // tecka se v tomto pripade nezobrazuje
      }
    
    


    
    if (styl == 0)
      {
    
        
        //  ------------------ rad desetitisicu  - tohle se pouzije jen pri mereni kladneho svetla na 3 desetinna mista ----------------------
        if (cislo > 9999)
          {
            D_pamet[4] = graf_def[cislo / 10000];
            cislo = cislo % 10000;
            zobraz_nuly = true;
          }
        else
          {
            if (zobraz_nuly == true)                      D_pamet[4] = graf_def[0];   // Znak '0'
            else                                          D_pamet[4] = 0;             // nebo prazdny znak
          }

      }

    // pripadne zaporne znamenko se zapise na levou segmentovku (index 4)
    if (znamenko == true)    D_pamet[4] = D_pamet[4] | 0b01000000;                    // k puvodnimu znaku se prida znamenko "-" (napriklad pri prubeznem mereni teploty se nemaze levy horni segment)



    //  ------------------ rad tisicu ----------------------
    if (pozice_tecky == 3) zobraz_nuly = true;
    if (cislo > 999)
      {
        D_pamet[3] = graf_def[cislo / 1000];
        cislo = cislo % 1000;
        zobraz_nuly = true;
      }
    else
      {
        if (zobraz_nuly == true)                          D_pamet[3] = graf_def[0];   // Znak '0'
        else                                              D_pamet[3] = 0;             // nebo prazdny znak
      }

          

    //  ------------------- rad stovek ----------------------
    if (pozice_tecky == 2) zobraz_nuly = true;

    if (cislo > 99)
      {
        D_pamet[2] = graf_def[cislo / 100];
        cislo = cislo % 100;
        zobraz_nuly = true;
      }
    else
      {
        if (zobraz_nuly == true)                          D_pamet[2] = graf_def[0];   // Znak '0'
        else                                              D_pamet[2] = 0;             // nebo prazdny znak
      }


    //  -------------------- rad desitek --------------------
    if (pozice_tecky == 1) zobraz_nuly = true;

    if (cislo > 9)
      {
        D_pamet[1] = graf_def[cislo / 10];
        cislo = cislo % 10;
      }
    else
      {
        if (zobraz_nuly == true)                          D_pamet[1] = graf_def[0];   // Znak '0'
        else                                              D_pamet[1] = 0;             // nebo prazdny znak
      }


    //  ------- rad jednotek (prava sedmisegmentovka) -------
    D_pamet[0] = graf_def[cislo];

    if (styl == 2)                                                                    // zobrazeni "L   0" az "L  -99" pro kladne cislo 0 az 99
      {
        if (posledni_n > 0)  D_pamet[2] = 64;                                         // minus na prostredni sedmisegmentovku
        else                 D_pamet[2] =  0;                                         // na prostredni sedmisegmentovku nic
        pozice_tecky = 0;                                                             // tecka se v tomto pripade nezobrazuje
      }


    pripoj_tecku();

    if (styl == 3)                                                                    // zobrazeni cisla ve formatu "-nn- "
      {
        D_pamet[4] = 64;                                                              // na prvni sedmisegmentovku zleva (rad desetitisicu) se zapise pomlcka
        D_pamet[1] = 64;                                                              // na druhou sedmisegmentovku zprava (rad desitek) se zapise pomlcka
        D_pamet[0] =  0;                                                              // prvni sedmisegmentovka zprava (rad jednotek) se smaze
      }

    if (predtext == 1)
      {
        D_pamet[4] = 246;                                                             // na prvni sedmisegmentovku zleva (rad desetitisicu) znak 'H.'
        D_pamet[3] = 241;                                                             // na druhou sedmisegmentovku zleva (rad tisicu) znak 'F.'
      }
    
    if (predtext == 2)
      {
        D_pamet[4] = 80;                                                              // na prvni sedmisegmentovku zleva (rad desetitisicu) znak 'r'
        D_pamet[3] = 222;                                                             // na druhou sedmisegmentovku zleva (rad tisicu) znak 'd.'
      }

    if (predtext == 3)
      {
        D_pamet[4] = 237;                                                             // na prvni sedmisegmentovku zleva (rad desetitisicu) znak 'S.'
        D_pamet[3] = 241;                                                             // na druhou sedmisegmentovku zleva (rad tisicu) znak 'F.'
      }

    
    aktualizuj_displej();                                                             // Presype cele pole 'D_pamet[]' po seriove komunikaci do displeje

  }
//---------------------- konec obsluhy displeje 5x7 znaku -------------------
#endif






//----------------------------------------------
// K jedne sedmisegmentovce prida jeste desetinnou tecku, ostatni tecky smaze
void pripoj_tecku(void)
  {
    for (byte i = 1; i < 4 ; i++)                                                     // (na nulte pozici tecka nikdy nesviti, proto zacina smycka od 1)
      {
        if (pozice_tecky == i) D_pamet[i] = D_pamet[i] | 0b10000000;                  // rozsvit nejvyssi bit
        else                   D_pamet[i] = D_pamet[i] & 0b01111111;                  // zhasni nejvyssi bit
      }
  }
//----------------------------------------------
  
